#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include "boilerplate.h"

uint32_t
    rawWC,
    fiveUniqWC
;

void findWords(signature* sigs, uint32_t len) {
    for (uint32_t i1 = 0; i1 < len; i1++) {
        uint32_t a = sigs[i1].sign;

        for (uint32_t i2 = i1+1; i2 < len; i2++) {
            uint32_t b = sigs[i2].sign;
            if (a & b) { continue; }
            uint32_t ab = a | b;
            PRINT2

            for (uint32_t i3 = i2+1; i3 < len; i3++) {
                uint32_t c = sigs[i3].sign;
                if (ab & c) { continue; }
                uint32_t abc = ab | c;
                PRINT3

                for (uint32_t i4 = i3+1; i4 < len; i4++) {
                    uint32_t d = sigs[i4].sign;
                    if (abc & d) { continue; }
                    uint32_t abcd = abc | d;
                    PRINT4

                    for (uint32_t i5 = i4+1; i5 < len; i5++) {
                        uint32_t e = sigs[i5].sign;
                        if (abcd & e) { continue; }
                        printf("%s, %s, %s, %s, %s\n", sigs[i1].word, sigs[i2].word, sigs[i3].word, sigs[i4].word, sigs[i5].word);

                        #if FIND_ONE
                            goto loopend;
                        #endif

                    }
                }
            }
        }
    }
    #if FIND_ONE
        loopend:
    #endif
    return;
}

signature* makeArray(FILE * f) {
    signature* sigs = (signature*) calloc(WORDS, sizeof(signature));
    char word[WORDLEN + sizeof(char)]; // 5 letters + \n

    while (fread(word, sizeof(char), WORDLEN + sizeof(char), f) != 0) {
        rawWC++;
        // only assign sign so far, more efficient
        uint32_t s = getsig(word);
        if (s != 0) {
            // no duplicate word letters in word
            sigs[fiveUniqWC].word = strndup(word, 5);
            sigs[fiveUniqWC].sign = s;
            fiveUniqWC++;
        }
    }

    return sigs;
}

int main(int argc, char * argv[]) {
#if TIME_SECTIONS
    clock_t prog_start = clock();
#endif

#if ! ASSUME_SAFE
    if (argc != 2) {
        fprintf(stderr, "usage: %s file\n", argv[0]);
        return 2;
    }
#endif

    FILE * f = fopen(argv[1], "r");

#if ! ASSUME_SAFE
    if (f == NULL) {
        fprintf(stderr, "%s,  %s,  no such file or directory\n", argv[0], argv[1]);
        return 2;
    }
#endif

    START_TIME("making array")
    signature* sigs = makeArray(f);
    END_TIME
    fclose(f);

#if PRINT_INTERMEDIATES
    fprintf(stderr, "INTERMEDIATE: read %u words\n", rawWC);
    fprintf(stderr, "INTERMEDIATE: kept %u words with 5 unique letters\n", fiveUniqWC);
#endif

#if DELETE
    START_TIME("sorting")
    qsort(sigs, fiveUniqWC, sizeof(signature), compare);
    END_TIME

    START_TIME("removing duplicates")
    uint32_t cookedWC = rmdups(sigs, fiveUniqWC);
    END_TIME
#else
    uint32_t cookedWC = fiveUniqWC;
#endif

#if PRINT_INTERMEDIATES
    fprintf(stderr, "INTERMEDIATE: ended with %u totally unique words\n", cookedWC);
#endif
    START_TIME("finding words")
    findWords(sigs, cookedWC);
    END_TIME

#if TIME_SECTIONS
    clock_t prog_end = clock();
    fprintf(stderr, "%s took %fs total\n", argv[0], ((double)(prog_end - prog_start)) / CLOCKS_PER_SEC);
#endif

    return 0;
}